#include "TestApp.h"

#include <iostream>
#include <fstream>

TestApp::TestApp(Fl_Window *argMainWin, fk_Window *argDrawWin)
	: fkut_AppBase(argMainWin, argDrawWin),				// eNX̃RXgN^Ăяo
	tb(argDrawWin, &camera), playerBox(4.0, 4.0, 4.0)	// XggăoϐɏlZbg
{
	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0, 1.0, 1.0);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(0.5, -1.0, 0.0);

	// ̂̐ݒ
	playerModel.setShape(&playerBox);
	playerModel.setMaterial(Cyan);
	playerModel.setSmoothMode(true);
	playerModel.glMoveTo(0.0, 15.0, 0.0);
	playerOBB.setBlockSize(4.0, 4.0, 4.0);
	playerOBB.setModel(&playerModel);

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	scene.entryModel(&playerModel);
	// }bṽGg[
	map.entryScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 100.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	// V[̃ZbgiX}[gɂˁBBBj
	drawWin->setScene(&scene);


	// ID(-1)Ń^[QbgȂ
	targetID = -1;

	// eNX`
	texAnime.setSize(20.0, 20.0);

	// u[̏
	block.setBlockSize(2.0, 2.0, 20.0);
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);
	blockModel.glMoveTo(0.0, 0.0, -10.0);
	blockModel.setParent(&playerModel);
	scene.entryModel(&blockModel);

	return;
}

TestApp::~TestApp(void)
{
}

void TestApp::calcTestQtoM(void)
{
	// sƃNH[^jIɂxNg]̎
	fk_Quaternion	q;
	fk_Matrix		matQ, matE;
	fk_HVector		vecD, vecU, vecR;

	vecD.set(0.0, 0.0, -1.0, 0.0);
	vecU.set(0.0, 1.0,  0.0, 0.0);

	matE.makeEuler(FK_PI, FK_PI, -FK_PI);
	q.makeEuler(FK_PI, FK_PI, -FK_PI);
	// NH[^jI̒l_CNgɉ]s𐶐@
	matQ[0][0] = 1.0 - 2.0*q.v.y*q.v.y - 2.0*q.v.z*q.v.z;
	matQ[0][1] = 2.0*q.v.x*q.v.y - 2.0*q.s*q.v.z;
	matQ[0][2] = 2.0*q.v.x*q.v.z + 2.0*q.s*q.v.y;
	matQ[1][0] = 2.0*q.v.x*q.v.y + 2.0*q.s*q.v.z;
	matQ[1][1] = 1.0 - 2.0*q.v.x*q.v.x - 2.0*q.v.z*q.v.z;
	matQ[1][2] = 2.0*q.v.y*q.v.z - 2.0*q.s*q.v.x;
	matQ[2][0] = 2.0*q.v.x*q.v.z - 2.0*q.s*q.v.y;
	matQ[2][1] = 2.0*q.v.y*q.v.z + 2.0*q.s*q.v.x;
	matQ[2][2] = 1.0 - 2.0*q.v.x*q.v.x - 2.0*q.v.y*q.v.y;

	// ̖߂ĂԂƃfobOEBhEg郂[hɂȂ
	fk_SetErrorMode(FK_ERR_BROWSER_INTERACTIVE);

	vecR = matE*vecD;
	vecR.Print("matE*vecD");	// ŃxNg̒loB[
	vecR = matE*vecU;
	vecR.Print("matE*vecU");	
	vecR = matQ*vecD;
	vecR.Print("matQ*vecD");	
	vecR = matQ*vecU;
	vecR.Print("matQ*vecU");

	return;
}

void TestApp::initVLine(void)
{
	// windowshowĂ炶ȂcgInit()Ȃ
	vLine.cgInit();
	if(!img.readBMP("effect/1d_cyan.bmp")) fl_alert("readBMP() err!");
	vLine.setImage(&img);
	vLine.pushLine(fk_Vector(-100.0, 0.0, 0.0), fk_Vector(100.0, 0.0, 0.0), 50.0);
	scene.entryModel(&vLine);

	return;
}

void TestApp::init(void)
{
	// {[C(RXgN^ł͎s)
	initVLine();

	return;
}

bool TestApp::procLoop(void)
{
	// J XZ Ƃɐis
	fwdU = camera.getVec();
	fwdU.y = 0.0;
	fwdU.normalize();
	// OςŉEQbg
	fwdR = fwdU ^ fk_Vector(0.0, 1.0, 0.0);

	// Wv̏x XZ ̊x悹
	if(eveMan.getKeyStatus(' ') == FKUT_SW_DOWN) {
		acc.x = spd.x;
		acc.z = spd.z;
		acc.y = 2.0;
	}

	// n㎞͓x^A󒆂ł͉x
	spd.init();
	if(eveMan.getSpecialKeyStatus(FK_UP) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc += fwdU*0.1;
		else spd += fwdU*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_DOWN) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc -= fwdU*0.1;
		else spd -= fwdU*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_LEFT) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc -= fwdR*0.1;
		else spd -= fwdR*0.5;
	}
	if(eveMan.getSpecialKeyStatus(FK_RIGHT) >= FKUT_SW_DOWN) {
		if(abs(acc.y) > 0.0) acc += fwdR*0.1;
		else spd += fwdR*0.5;
	}
	if(spd.normalize()) spd *= 0.5;

	// d͉x
	acc.y -= 0.098;
	if(acc.x*acc.x + acc.z*acc.z > 0.5*0.5) {
		double tmpSpdLen = sqrt(acc.x*acc.x + acc.z*acc.z);
		acc.x *= 0.5/tmpSpdLen;
		acc.z *= 0.5/tmpSpdLen;
	} else {
		acc.x *= 0.9;
		acc.z *= 0.9;
	}

	// x𑬓xɏ悹
	spd += acc;

	// }bv̏Փ˔Ăяo
	if(map.procCollision(&playerOBB, &spd)) {
		// Ԓlbool̏ꍇYɑ΂锽͂Ă̂ŉxNA
		acc.init();
	}
	// ̎_ŏՓ˂̔͂xɉĂ

	// x𑀍샂fɉĎۂɓ
	playerModel.glTranslate(spd);
	camera.glTranslate(spd.x, 0.0, spd.z);
	tb.setLookTo(fk_Vector(playerModel.getPosition().x, 0.0, playerModel.getPosition().z));

	tb.update();

	// Tv̌Ăяo
	changeTarget();
	texAnime.update(&camera);

	if(eveMan.getKeyStatus('z') == FKUT_SW_PRESS) {
		blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/10.0);
		blur.update(&scene, &blockModel, true);
	} else {
		blur.update(&scene, &blockModel, false);
	}

	return true;
}

// G^[L[Ń^[QbgύXĂAƉ]̊
void TestApp::changeTarget(void)
{
	if(eveMan.getSpecialKeyStatus(FK_ENTER) == FKUT_SW_DOWN) {
		targetID++;
		if(targetID >= 7) {
			targetID = -1;
			scene.removeModel(&texAnime);
		} else {
			scene.entryModel(&texAnime);
		}
		fk_Printf("TARGET = %d", targetID);
	}
	if(targetID != -1) {
		fk_Quaternion	qA, qB, qAns;
		fk_Vector		targetPos;

		targetPos = map.getBlockModel(targetID)->getPosition();
		texAnime.glMoveTo(targetPos);
		targetPos.y = playerModel.getPosition().y;

		qA.makeEuler(playerModel.getAngle());
		playerModel.glFocus(targetPos);
		qB.makeEuler(playerModel.getAngle());
		playerModel.glAngle(qA.getEuler());

		qAns = fk_Math::quatInterSphere(qA, qB, 0.5);
		playerModel.glAngle(qAns.getEuler());
	}

	return;
}
