#include "TexAnimeEffect.h"

TexAnimeEffectModel::TexAnimeEffectModel(void)
{
	step = 0;

	rect.readPNG("effect/Locus.png");
	rect.setTextureMode(FK_TEX_REPLACE);
	rect.setTexRendMode(FK_TEX_REND_SMOOTH);
	rect.setTextureSize(100.0, 100.0);
	this->setShape(&rect);
}

TexAnimeEffectModel::~TexAnimeEffectModel(void)
{
}

void TexAnimeEffectModel::setSize(double w, double h)
{
	rect.setTextureSize(w, h);
}

void TexAnimeEffectModel::update(fk_Model *ref_camera)
{
	/*
	fk_TexCoord(0.0, 1.0);
	fk_TexCoord(2.0, 0.8);
	fk_TexCoord(2.0, 1.0);
	fk_TexCoord(4.0, 0.8);
	fk_TexCoord(4.0, 1.0);
	fk_TexCoord(6.0, 0.8);
	fk_TexCoord(6.0, 1.0);
	fk_TexCoord(8.0, 0.8);
	fk_TexCoord(8.0, 1.0);
	fk_TexCoord(1.0, 0.8);
	*/
	rect.setTextureCoord((double)(step%5)*0.2, 1.0-(double)(step/5)*0.2,
							(double)((step%5)+1)*0.2, 1.0-(double)((step/5)+1)*0.2);
	step++;
	if(step >= 25) step = 0;

	this->glFocus(ref_camera->getInhPosition());
	this->loFocus(0.0, 0.0, 1.0);

	return;
}

void TexAnimeEffectModel::preShader()
{
	glBlendFunc(GL_ONE, GL_ONE);
	glDepthMask(GL_FALSE);
	glDisable(GL_DEPTH_TEST);
}

void TexAnimeEffectModel::postShader()
{
	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}
